<?
/**** MAIN TASK info@maintask.net ****/
//require_once($CFG->libdir . "/generic_object.php");
require_once("generic_object.php");
class direccion extends genericObject{
//class direccion extends entity{

	var $strAddress;
	var $strAddressOriginal;
	var $blockWidth = 0.000718616; //(80 * 0.0000089827);	//Ancho de las cuadras para la extrapolacin
	var $offset=8;
	var $error="";
	var $errorCode="";

	var $errors=array(
				0=>"",
				1=>"Direccin vaca",
				2=>"No se puede traducir la direccin",
				3=>"La entidad no existe en los arcos",
				4=>"Es una avenida, pero no est en la base de datos",
				5=>"Direccin extrapolada",
				6=>"Fuera de cobertura",
				7=>"Hay ms de un arco con esa direccin, y no se proporcion un barrio.",
				8=>"Hay ms de un arco con esa direccin, y el barrio no se encontr.",
				9=>"Hay ms de un arco con esa direccin, y el barrio existe, pero ninguno de los arcos se cruza con el barrio.",
				10=>"La direccin es del tipo 'AVENIDA #', pero no se sabe si es 'Avenida Calle #' o 'Avenida Carrera #'."
			);

	var $nueva = 0;
	var $tipo_via = "";
	var $nombre_comun = "";
	var $nomenclatura = "";
	var $nom_letra = "";
	var $nom_bis = "";
	var $let_bis = "";
	var $generadora = "";
	var $gen_letra = "";
	var $gen_bis = "";

	var $cardinality = "";
	var $gen_cardinality = "";

	var $distancia = "";

	var $defaultEast = 1;
	var $defaultSouth = 1;

	var $clSouth = 1;	//El Sur/Norte va sobre las calles?
	
	var $este = 0;
	var $sur = 0;

	var $suffix = "";
	var $idAvenida = "";
	var $x = "";
	var $y = "";

	var $municipio = "";
	var $barrio = "";
	var $id_barrio = "";

	var $srid = 2;
	var $the_geom = "NULL";

	var $numExtrapolations=0;
	var $currentExtrapolation=1;
	var $curExtrapolationTV=0;
	var $extrapolated=0;
	var $extrapolating=0;
	var $extrapolatingTV=0;

	var $extrapolationBlocks = NULL;
	var $extrapolationSense = NULL;
	
	var $db;


/*	CONSTRUCTOR	*/
	function direccion($db,$strAddress){
		$this->db=$db;
		$strAddress=trim($strAddress);
		if($strAddress==""){
			$this->set("errorCode",1);
//			$this->set("error","Direccin vaca.");
			return(FALSE);
		}
		$this->set("strAddress",$strAddress);
		$this->set("strAddressOriginal",$strAddress);
		$this->clean();

		return(TRUE);
	}

	function ubicar_punto(){
	/* Guarda en $this->x, $this->y las coordenadas del punto que queda
  	 a una distancia $this->distancia sobre la lnea definida por los
  	 puntos $this->arc["x_origen"],$this->arc["y_origen"],$this->arc["x_final"],$this->arc["y_final"] y perpendicularmente a una distancia
  	 $this->offset
		 Ademas se multiplica por una constante de equivalencia en grados cuando la base de datos esta en LL
		$this->distancia=$this->distancia*0.0000089827; en metros la constante es 1
		$this->offset=$this->offset*0.0000089827; en metros la constante es 1
	*/
		$this->blockWidth=$this->blockWidth*$this->currentExtrapolation;
		//OJO:VOY AC
		//TOCA EVALUAR LA EXTRAPOLACIN
		if($this->extrapolating){
			$dx = $this->arc["x_final"]-$this->arc["x_origen"];
			$dy = $this->arc["y_final"]-$this->arc["y_origen"];
			$alfa = @atan($dy/$dx);
			$this->este ? $sentidoX=-1: $sentidoX=1;
		 	$this->sur ? $sentidoY=1: $sentidoY=-1;
			switch($this->extrapolationSense){
				case 1:	
					$x=$this->blockWidth * sin($alfa);
					$y=$this->blockWidth * cos($alfa);
					$this->arc["x_final"]+=$x*$sentidoX;
					$this->arc["x_origen"]+=$x*$sentidoX;
					$this->arc["y_final"]+=$y*$sentidoY;
					$this->arc["y_origen"]+=$y*$sentidoY;
				break;

				case 2:
					$x=abs($this->blockWidth * cos($alfa));
					$y=($this->blockWidth * sin($alfa));
					$punto["x_origen"]=$this->arc["x_origen"];
					$punto["x_final"]=$this->arc["x_final"];
					$punto["y_origen"]=$this->arc["y_origen"];
					$punto["y_final"]=$this->arc["y_final"];
					$this->arc["x_final"]=$this->arc["x_origen"];
					$this->arc["y_final"]=$this->arc["y_origen"];
					if($punto["x_origen"]>$punto["x_final"]) $this->arc["x_origen"]=$punto["x_origen"] + $x;
					else $this->arc["x_origen"]=$punto["x_origen"] - $x;
					if($punto["y_origen"] > $punto["y_final"]) $this->arc["y_origen"]=$punto["y_origen"] + $y;
					else $this->arc["y_origen"]=$punto["y_origen"] - $y;
				break;

				case 3:
					$x=$this->blockWidth * sin($alfa);
					$y=$this->blockWidth * cos($alfa);
					$this->arc["x_final"]-=$x*$sentidoX;
					$this->arc["x_origen"]-=$x*$sentidoX;
					$this->arc["y_final"]-=$y*$sentidoY;
					$this->arc["y_origen"]-=$y*$sentidoY;
				break;
				
				case 4:
					$x=abs($this->blockWidth * cos($alfa));
					$y=abs($this->blockWidth * sin($alfa));
					$punto["x_origen"]=$this->arc["x_origen"];
					$punto["x_final"]=$this->arc["x_final"];
					$punto["y_origen"]=$this->arc["y_origen"];
					$punto["y_final"]=$this->arc["y_final"];
					$this->arc["x_origen"]=$this->arc["x_final"];
					$this->arc["y_origen"]=$this->arc["y_final"];
					if($punto["x_origen"]<$punto["x_final"]) $this->arc["x_final"]=$punto["x_final"] + $x;
					else $this->arc["x_final"]=$punto["x_final"] - $x;
					if($punto["y_origen"] < $punto["y_final"]) $this->arc["y_final"]=$punto["y_final"] + $y;
					else $this->arc["y_final"]=$punto["y_final"] - $y;
				break;
				

			
			}
//			preguntar($this->arc);
		}
		if($this->distancia%2 == 0) $this->offset *= -1;
		$distancia=$this->distancia*0.8*0.0000089827;	//Yardas -> Metros -> Grados
		$offset=$this->offset*0.0000089827;
		$dx = $this->arc["x_final"]-$this->arc["x_origen"];
		$dy = $this->arc["y_final"]-$this->arc["y_origen"];
		$complemento = 0;
		if ($dx < 0 && $dy < 0) {$complemento = M_PI;$offset=$offset*-1;}
		if ($dx > 0 && $dy < 0) {$complemento = M_PI*-1;$offset=$offset*-1;}
		@$angulo=(atan($dy/$dx))+ $complemento;
		if ($angulo<=0){
			$nx=$this->arc["x_origen"] - (cos($angulo)*$distancia);
			$ny=$this->arc["y_origen"] - (sin($angulo)*$distancia);
		}
		else{
			$nx=$this->arc["x_origen"] + (cos($angulo)*$distancia);
			$ny=$this->arc["y_origen"] + (sin($angulo)*$distancia);
		}
		$this->x=$nx-(sin($angulo)*$offset);
		$this->y=$ny+(cos($angulo)*$offset);
//		preguntar($this->x);
//		preguntar($this->y);
	}

	function buscar(){
	/*	OJO: LA cardINALIDAD	*/
		if(
				(($this->tipo_via==1 || $this->tipo_via==3 || $this->tipo_via==5) && $this->clSouth==0) ||
				(($this->tipo_via==2 || $this->tipo_via==4 || $this->tipo_via==6) && $this->clSouth==1)
			){
			$this->set("cardinality",$this->este);
			$this->set("gen_cardinality",$this->sur);
		}
		elseif(
				(($this->tipo_via==2 || $this->tipo_via==4 || $this->tipo_via==6) && $this->clSouth==0) ||
				(($this->tipo_via==1 || $this->tipo_via==3 || $this->tipo_via==5) && $this->clSouth==1)
			){
			$this->set("cardinality",$this->sur);
			$this->set("gen_cardinality",$this->este);
		}
		else{	//Si es avenida:
			if($this->get("defaultEast") != $this->este) $this->set("gen_cardinality",$this->este);
			else $this->set("gen_cardinality",$this->sur);
			if($this->get("defaultSouth") != $this->sur) $this->set("gen_cardinality",$this->sur);
			else $this->set("gen_cardinality",$this->este);
		}

		$condicion="municipio='" . $this->municipio . "' AND nueva = " . $this->nueva . "\n";
		($this->nom_letra=="") ? $condicion.=" AND letn IS NULL" : $condicion.=" AND letn='" . $this->nom_letra . "'\n";
		($this->nom_bis=="") ? $condicion.=" AND bis IS NULL" : $condicion.=" AND bis='" . $this->nom_bis . "'\n";
		($this->let_bis=="") ? $condicion.=" AND letbis IS NULL" : $condicion.=" AND letbis='" . $this->let_bis . "'\n";
		($this->generadora=="") ? $condicion.=" AND g_nv IS NULL" : $condicion.=" AND g_nv='" . $this->generadora . "'\n";
		($this->gen_letra=="") ? $condicion.=" AND g_ln IS NULL" : $condicion.=" AND g_ln='" . $this->gen_letra . "'\n";
		($this->gen_bis=="") ? $condicion.=" AND g_bis IS NULL" : $condicion.=" AND g_bis='" . $this->gen_bis . "'\n";

		if($this->idAvenida==""){
			($this->tipo_via=="") ? $condicion.=" AND tipo_via IS NULL" : $condicion.=" AND tipo_via='" . $this->tipo_via . "'\n";
			($this->nomenclatura=="") ? $condicion.=" AND numvia IS NULL" : $condicion.=" AND numvia='" . $this->nomenclatura . "'\n";
			($this->cardinality=="") ? $condicion.=" AND card = '0'" : $condicion.=" AND card='" . $this->cardinality . "'\n";
			($this->gen_cardinality=="") ? $condicion.=" AND g_card = '0'" : $condicion.=" AND g_card='" . $this->gen_cardinality . "'\n";

			$query= "SELECT * FROM sig_gr_entidades WHERE $condicion";
			$query_highlight=preg_replace("/((g_nv|numvia)='[0-9]*')/","<font color=\"#FF0000\">\$1</font>",$query);
//		echo "<pre>".$query_highlight . "<br></pre>";
		}
		else{
//preguntar($this->idAvenida);
			$query= "
				SELECT * FROM sig_gr_entidades WHERE
					$condicion AND
					g_card='" . $this->gen_cardinality . "' AND
					nomb_id='" . $this->idAvenida . "'
			";
		}
		$qid=$this->db->sql_query($query);
		if($this->db->sql_numrows($qid)==1 || ($this->municipio!=76001 && $this->db->sql_numrows($qid)>1)){
			$ent=$this->db->sql_fetchrow($qid);
			$this->arc=$ent;
//			preguntar($this->idAvenida);
			if($this->idAvenida != "") $this->tipo_via=$this->arc["tipo_via"];
			return TRUE;
		}
		elseif($this->db->sql_numrows($qid)>1){
			if($this->barrio==""){
				$this->errorCode=7;
				return(false);
			}
			else{
				$qbarrio=$this->db->sql_query("SELECT id FROM barrios WHERE nombre_comun LIKE UPPER('" . $this->barrio . "') AND municipio='" . $this->municipio . "'");
				if($barrio=$this->db->sql_fetchrow($qbarrio)){
					$this->id_barrio = $barrio["id"];
					$qvert=$this->db->sql_query("SELECT X, Y FROM barrios_poligonos WHERE idPoligono='" . $this->id_barrio . "' ORDER BY id");
					$arreglox=array();
					$arregloy=array();
					$i=0;
					while ($vertices=$this->db->sql_fetchrow($qvert)){
						$arreglox[$i]=$vertices["X"];
						$arregloy[$i]=$vertices["Y"];
						$i++;
					}
					while($ent=$this->db->sql_fetchrow($qid)){

						if (pnpoly($arreglox,$arregloy,$ent["x_origen"],$ent["y_origen"])){
							$this->arc=$ent;
							return(TRUE);
						}
					}
					$this->errorCode=9;
					return(FALSE);
				}
				else{
					$this->errorCode=8;
					return(false);
				}
			}
		}
		elseif($this->tipo_via==0){
			$this->errorCode=4;
			return(false);
		}
		else{
//PARA VERIFICAR CUANDO ES CL O KR CON AC Y AK Y AL REVS; Y DG POR CL Y TV POR KR:
			if($this->extrapolatingTV==0){
				$tipo_via_original=$this->tipo_via;
				$this->extrapolating=1;
				$this->extrapolatingTV=1;
				$tipo_via="";
				switch($this->tipo_via){
	//CL POR AC://KR POR AK://AC POR CL://AK POR KR://DG POR CL://TV POR KR:
					case 3: $tipo_via=1; break;
					case 4: $tipo_via=2; break;
					case 1: $tipo_via=3; break;
					case 2: $tipo_via=4; break;
					case 5: $tipo_via=3; break;
					case 6: $tipo_via=4; break;
				}
				if($tipo_via!=""){
					$this->tipo_via=$tipo_via;
					if($success=$this->buscar()){
						$this->extrapolated=$tipo_via;
						$this->set("errorCode",5);//Direccin extrapolada
					}
					$this->tipo_via=$tipo_via_original;
					if($success){
//						preguntar(__LINE__);
						return($success);
					}
				}
				$this->extrapolating=0;
			}
			if($this->extrapolating==0){
		//PARA LA EXTRAPOLACIN:
		//Voy a intentar buscar en la base de datos el arco ms cercano:
				if($this->tipo_via==1 || $this->tipo_via==3 || $this->tipo_via==5) $condicion_tipo_via="(tipo_via='1' OR tipo_via='3' OR tipo_via='5')";
				else $condicion_tipo_via="(tipo_via='2' OR tipo_via='4' OR tipo_via='6')";
				
//ARRIBA:-------------------------
				$condicion="municipio='" . $this->municipio . "' AND nueva = " . $this->nueva . "\n";
				($this->nom_letra=="") ? $nom_letra=64 : $nom_letra=ord($this->nom_letra);
				$condicion.=" AND ((ASCII(letn)>'$nom_letra' AND numvia='" . $this->nomenclatura . "') OR numvia > '" . $this->nomenclatura . "')\n";
//				($this->nom_bis=="") ? $condicion.=" AND bis IS NULL" : $condicion.=" AND bis='" . $this->nom_bis . "'\n";
				($this->generadora=="") ? $condicion.=" AND g_nv IS NULL" : $condicion.=" AND g_nv='" . $this->generadora . "'\n";
				($this->gen_letra=="") ? $condicion.=" AND g_ln IS NULL" : $condicion.=" AND g_ln='" . $this->gen_letra . "'\n";
//				($this->gen_bis=="") ? $condicion.=" AND g_bis IS NULL" : $condicion.=" AND g_bis='" . $this->gen_bis . "'\n";
				$condicion.=" AND $condicion_tipo_via\n";
				($this->cardinality=="") ? $condicion.=" AND card = '0'" : $condicion.=" AND card='" . $this->cardinality . "'\n";
				($this->gen_cardinality=="") ? $condicion.=" AND g_card = '0'" : $condicion.=" AND g_card='" . $this->gen_cardinality . "'\n";
				$query= "SELECT * FROM sig_gr_entidades WHERE $condicion ORDER BY numvia,letn LIMIT 1";
//				preguntar($query);
				$qid=$this->db->sql_query($query);
				$min=999;
				if($arco_superior=$this->db->sql_fetchrow($qid)){
//					preguntar($arco_superior);
//Averiguar a cuntas cuadras hacia arriba est el arco ms cercano...
					($arco_superior["letn"]=="") ? $nom_letra_found=64 : $nom_letra_found=ord($arco_superior["letn"]);
//				$cuadras_arco_superior=$nom_letra_found+$arco_superior["numvia"]-($nom_letra+$this->nomenclatura);
					$cuadras_arco_superior=$nom_letra_found+$arco_superior["numvia"]-($this->nomenclatura+64);
					if($cuadras_arco_superior<$min){
						$min=$cuadras_arco_superior;
						$sentido=1;
						$this->arc=$arco_superior;
					}
//					preguntar($cuadras_arco_superior);
				}
//ABAJO:-------------------------
				$condicion="municipio='" . $this->municipio . "' AND nueva = " . $this->nueva . "\n";
				if($this->nom_letra=="") $condicion.=" AND numvia < '" . $this->nomenclatura . "'";
				else $condicion.=" AND (((ASCII(letn)<'" . ord($this->nom_letra) . "' OR letn IS NULL) AND numvia='" . $this->nomenclatura . "') OR numvia < '" . $this->nomenclatura . "')\n";
				($this->nom_bis=="") ? $condicion.=" AND bis IS NULL" : $condicion.=" AND bis='" . $this->nom_bis . "'\n";
				($this->generadora=="") ? $condicion.=" AND g_nv IS NULL" : $condicion.=" AND g_nv='" . $this->generadora . "'\n";
				($this->gen_letra=="") ? $condicion.=" AND g_ln IS NULL" : $condicion.=" AND g_ln='" . $this->gen_letra . "'\n";
				($this->gen_bis=="") ? $condicion.=" AND g_bis IS NULL" : $condicion.=" AND g_bis='" . $this->gen_bis . "'\n";
				$condicion.=" AND $condicion_tipo_via\n";
				($this->cardinality=="") ? $condicion.=" AND card = '0'" : $condicion.=" AND card='" . $this->cardinality . "'\n";
				($this->gen_cardinality=="") ? $condicion.=" AND g_card = '0'" : $condicion.=" AND g_card='" . $this->gen_cardinality . "'\n";
				$query= "SELECT * FROM sig_gr_entidades WHERE $condicion ORDER BY numvia DESC,letn DESC LIMIT 1";
//				preguntar($query);
				$qid=$this->db->sql_query($query);
				if($arco_inferior=$this->db->sql_fetchrow($qid)){
//					preguntar($arco_inferior);
//Averiguar a cuntas cuadras hacia abajo est el arco ms cercano...
					($arco_inferior["letn"]=="") ? $nom_letra_found=64 : $nom_letra_found=ord($arco_inferior["letn"])-1;
					$cuadras_arco_inferior=$nom_letra+$this->nomenclatura - ($nom_letra_found+$arco_inferior["numvia"]);
					if($cuadras_arco_inferior<$min){
						$min=$cuadras_arco_inferior;
						$sentido=3;
						$this->arc=$arco_inferior;
					}
//					preguntar($cuadras_arco_inferior);
				}
//DERECHA:-------------------------
				$condicion="municipio='" . $this->municipio . "' AND nueva = " . $this->nueva . "\n";
				($this->nomenclatura=="") ? $condicion.=" AND numvia IS NULL" : $condicion.=" AND numvia='" . $this->nomenclatura . "'\n";
				($this->nom_letra=="") ? $condicion.=" AND letn IS NULL" : $condicion.=" AND letn='" . $this->nom_letra . "'\n";
				($this->gen_letra=="") ? $gen_letra=64 : $gen_letra=ord($this->gen_letra);
				$condicion.=" AND ((ASCII(g_ln)>'$gen_letra' AND g_nv='" . $this->generadora . "') OR g_nv > '" . $this->generadora . "')\n";
				$condicion.=" AND bis IS NULL\n";
				$condicion.=" AND g_bis IS NULL\n";
				$condicion.=" AND $condicion_tipo_via\n";
				($this->cardinality=="") ? $condicion.=" AND card = '0'" : $condicion.=" AND card='" . $this->cardinality . "'\n";
				($this->gen_cardinality=="") ? $condicion.=" AND g_card = '0'" : $condicion.=" AND g_card='" . $this->gen_cardinality . "'\n";
				$query= "SELECT * FROM sig_gr_entidades WHERE $condicion ORDER BY g_nv,g_ln LIMIT 1";
//				preguntar($query);
				$qid=$this->db->sql_query($query);
				if($arco_der=$this->db->sql_fetchrow($qid)){
//					preguntar($arco_der);
//Averiguar a cuntas cuadras a la derecha est el arco ms cercano...
					($arco_der["g_ln"]=="") ? $gen_letra_found=64 : $gen_letra_found=ord($arco_der["g_ln"]);
					$cuadras_arco_der=$gen_letra_found+$arco_der["g_nv"] - ($gen_letra+$this->generadora);
					if($cuadras_arco_der<$min){
						$min=$cuadras_arco_der;
						$sentido=2;
						$this->arc=$arco_der;
					}
//					preguntar($cuadras_arco_der);
				}
//IZQUIERDA:-------------------------
				$condicion="municipio='" . $this->municipio . "' AND nueva = " . $this->nueva . "\n";
				($this->nomenclatura=="") ? $condicion.=" AND numvia IS NULL" : $condicion.=" AND numvia='" . $this->nomenclatura . "'\n";
				($this->nom_letra=="") ? $condicion.=" AND letn IS NULL\n" : $condicion.=" AND letn='" . $this->nom_letra . "'\n";
				if($this->gen_letra=="") $condicion.=" AND g_nv < '" . $this->generadora . "'\n";
				else $condicion.=" AND (((ASCII(g_ln)<'" . ord($this->gen_letra) . "' OR g_ln IS NULL) AND g_nv='" . $this->generadora . "') OR g_nv < '" . $this->generadora . "')\n";
				($this->nom_bis=="") ? $condicion.=" AND bis IS NULL\n" : $condicion.=" AND bis='" . $this->nom_bis . "'\n";
				($this->gen_bis=="") ? $condicion.=" AND g_bis IS NULL\n" : $condicion.=" AND g_bis='" . $this->gen_bis . "'\n";
				$condicion.=" AND $condicion_tipo_via\n";
				($this->cardinality=="") ? $condicion.=" AND card = '0'" : $condicion.=" AND card='" . $this->cardinality . "'\n";
				($this->gen_cardinality=="") ? $condicion.=" AND g_card = '0'" : $condicion.=" AND g_card='" . $this->gen_cardinality . "'\n";
				$query= "SELECT * FROM sig_gr_entidades WHERE $condicion ORDER BY g_nv DESC,g_ln DESC LIMIT 1";
//				preguntar($query);
				$qid=$this->db->sql_query($query);
				if($arco_izq=$this->db->sql_fetchrow($qid)){
//					preguntar($arco_izq);
//Averiguar a cuntas cuadras a la izquierda est el arco ms cercano...
					($arco_izq["g_ln"]=="") ? $gen_letra_found=64 : $gen_letra_found=ord($arco_izq["g_ln"])-1;
					$cuadras_arco_izq=$gen_letra+$this->generadora - ($gen_letra_found+$arco_izq["g_nv"]);
					if($cuadras_arco_izq<$min){
						$min=$cuadras_arco_izq;
						$sentido=4;
						$this->arc=$arco_izq;
					}
//					preguntar($cuadras_arco_izq);
				}
//				preguntar($min."-".$this->numExtrapolations);
				if($min<=$this->numExtrapolations){
					$this->set("errorCode",5);
					$this->set("extrapolationBlocks",$min);
					$this->set("extrapolationSense",$sentido);
					$this->extrapolating=1;
//					preguntar($this->extrapolating);
					
//					preguntar($this->arc);
					return(TRUE);
				}
				return(FALSE);
				die("Chequeo Main Task");
				while($this->numExtrapolations>0){
					if($this->curExtrapolationTV==4){
						$this->curExtrapolationTV=1;
						$this->numExtrapolations--;
						$this->currentExtrapolation++;
					}
					else $this->curExtrapolationTV++;

					$nomenclatura = $this->nomenclatura;
					$nom_letra = $this->nom_letra;
					$nom_bis = $this->nom_bis;
					$generadora = $this->generadora;
					$gen_letra = $this->gen_letra;
					$gen_bis = $this->gen_bis;

					$this->increment();
//					preguntar($this);

					$this->extrapolating=1;
					$success=$this->buscar();

					if($success){
						$this->extrapolated=array($this->nomenclatura,$this->nom_letra,$this->nom_bis,$this->generadora,$this->gen_letra,$this->gen_bis);
						$this->set("errorCode",5);//Direccin extrapolada
//						preguntar(__LINE__);
						return($success);
					}
					$this->nomenclatura = $nomenclatura;
					$this->nom_letra = $nom_letra;
					$this->nom_bis = $nom_bis;
					$this->generadora = $generadora;
					$this->gen_letra = $gen_letra;
					$this->gen_bis = $gen_bis;
				}
			}
			$this->errorCode=3;
//			$this->error="La entidad no existe en los arcos";
//			preguntar(__LINE__);
			return(FALSE);
		}
	}

	function increment(){
		switch($this->curExtrapolationTV){
			case "1":
				if($this->idAvenida==""){
					$this->nomenclatura+=$this->currentExtrapolation;
					$this->nom_letra="";
					$this->nom_bis="";
				}
				break;
			case 2:
				$this->generadora+=$this->currentExtrapolation;
				$this->gen_letra="";
				$this->gen_bis="";
				break;
			case 3:
				if($this->idAvenida==""){
					$bis=0;
					if($this->nom_bis!="" && $this->currentExtrapolation!=1){
						$bis=1;
					}

					if($this->nom_bis!="" && $this->currentExtrapolation==1){
					}
					elseif(ereg("^[A-Z]\$",$this->nom_letra)){
						if(ord($this->nom_letra)-($this->currentExtrapolation-$bis)==64) $this->nom_letra="";
						elseif(ord($this->nom_letra)-($this->currentExtrapolation-$bis)>64)
							$this->nom_letra=chr(ord($this->nom_letra)-($this->currentExtrapolation-$bis));
						else{
							$ascii=ord($this->nom_letra)-($this->currentExtrapolation-$bis);
							$this->nom_letra="";
							$this->nomenclatura=$this->nomenclatura-64+$ascii;
						}
					}
					else $this->nomenclatura-=($this->currentExtrapolation-$bis);

					$this->nom_bis="";
				}
				break;
			case 4:
				for($cont=$this->currentExtrapolation;$cont>0;$cont--){
					if($this->gen_letra=="A"){
						$this->gen_letra="";
//						if($this->currentExtrapolation>1) $this->generadora--;
					}
					elseif(ereg("^[B-Z]\$",$this->gen_letra)) $this->gen_letra=chr(ord($this->gen_letra)-1);
					elseif($this->gen_letra!="") $this->gen_letra="";
					elseif($this->gen_bis!="") $this->gen_bis="";
					else $this->generadora--;

				}
				break;
		}
	}

	function locate(){

			$cont=0;
			if(!($this->buscar())){
			/*	--	Meter cdigo de extrapolacin	--	*/
			/*	--	Bsicamente es ir agregando o eliminando nmeros a la generadora y a la nomenclatura --	*/
				$qid=$this->db->sql_query("
					SELECT ID FROM sig_gr_inexistentes WHERE direccion = UPPER('" . $this->strAddressOriginal . "')
						AND municipio='" . $this->municipio . "'
				");
				if (!($obj=$this->db->sql_fetchrow($qid))){
					$qid=$this->db->sql_query("
						INSERT INTO sig_gr_inexistentes (municipio, direccion)
						VALUES ('" . $this->municipio . "', UPPER('" . $this->strAddressOriginal . "'))
					");
					$idInexistente=$this->db->sql_nextid($qid);
				}
				else $idInexistente=$obj["id"];
				return(FALSE);
			}
			if ($this->tipo_via == 1 || $this->tipo_via == 3 || $this->tipo_via == 5) $this->offset=$this->offset*-1;

			$this->ubicar_punto();

//			$this->the_geom="GeometryFromText('POINT(" . $this->x . " " . $this->y . ")'," . $this->srid . ")";
//			unset($this->arc);
			return(TRUE);

	}

	function searchCommonName(){
		$this->nombre_comun = preg_replace("/ +/", " ", $this->nombre_comun);
		$query="SELECT id_nomvia FROM sig_gr_nomvias WHERE
			municipio='" . $this->municipio . "'
			AND(
				nombre_comun LIKE UPPER('$this->nombre_comun') OR
				alias_1 LIKE UPPER('$this->nombre_comun') OR
				alias_2 LIKE UPPER('$this->nombre_comun')
			)
		";
		$qid=$this->db->sql_query($query);
		if ($ent=$this->db->sql_fetchrow($qid)){
			$this->idAvenida=$ent["id_nomvia"];
			return(TRUE);
		}
		return(FALSE);
	}

	function createCode(){
		if ($this->tipo_via=="AC") $this->tipo_via = "1";
		else if ($this->tipo_via=="AK") $this->tipo_via = "2";
		else if ($this->tipo_via=="CL") $this->tipo_via = "3";
		else if ($this->tipo_via=="KR") $this->tipo_via = "4";
		else if ($this->tipo_via=="DG") $this->tipo_via = "5";
		else if ($this->tipo_via=="TV") $this->tipo_via = "6";
		else if ($this->tipo_via=="AV") $this->tipo_via = "0";
		else if ($this->tipo_via=="AU") $this->tipo_via = "0";
	}

	function clean(){
/*
	Funcin que trata de limpiar o corregir los errores ms comunes
	en el ingreso de las direcciones...
*/
//		$this->strAddress=preg_replace("/([A-Z])([0-9])/","\\1 \\2",$this->strAddress);
    $this->strAddress=strtr($this->strAddress, "", "aeiouaeiou");
    $this->strAddress=strtoupper($this->strAddress);
    $this->strAddress=preg_replace("//", "A",$this->strAddress);
    $this->strAddress=preg_replace("//", "E",$this->strAddress);
    $this->strAddress=preg_replace("//", "I",$this->strAddress);
    $this->strAddress=preg_replace("//", "O",$this->strAddress);
    $this->strAddress=preg_replace("//", "U",$this->strAddress);
    
		$this->strAddress=preg_replace("/^[A-Z]++,/", "",$this->strAddress); // limpia el texto inicial en casos como BOSA,CL 80B S N 100C BIS 42
		
//	++NUEVO++
    $this->strAddress=preg_replace("/^([A-Z]*)([0-9])/", "$1 $2",$this->strAddress);
		
    $this->strAddress=preg_replace("/ L\\. ?/"," LC ",$this->strAddress);
    $this->strAddress=preg_replace("/[^0-9A-Z]/"," ",$this->strAddress);
    $this->strAddress=preg_replace("/( N | NO |NUMERO| NUM|#|N )/"," ",$this->strAddress);

    $this->strAddress=preg_replace("/^(AVENIDA|AVENID|AVDA|AVENI|AVEN|AVE|AVD) /", "AV ",$this->strAddress);

    $this->strAddress=preg_replace("/AV (CALLE|CALL|CLLE|CLL|CL|CAL|CLE) /", "AC ",$this->strAddress);
    $this->strAddress=preg_replace("/AV (CARRERA|KARRERA|CRRA|KRRA|CRA|KRA|KR|CR) /", "AK ",$this->strAddress);

    $this->strAddress=preg_replace("/^(AUTOPISTA|AUTOP|AUTO|AUT) /", "AU ",$this->strAddress);

    $this->strAddress=preg_replace("/(MANZANA|MANZ|MNZ) /", "MZ ",$this->strAddress);

    $this->strAddress=preg_replace("/^(CARRERA|KARRERA|CRRA|KRRA|CRA|KRA|CR) /", "KR ",$this->strAddress);
    $this->strAddress=preg_replace("/^(CALLE|CALL|CLLE|CLL|CAL|CLE) /", "CL ",$this->strAddress);
    $this->strAddress=preg_replace("/^(TRANSVERSAL|TRASNVERSAL|TRANSV|TRANV|TRAN|TRA|TRAV|TRAS|TRV|TR) /", "TV ",$this->strAddress);
    $this->strAddress=preg_replace("/^(DIAGONAL|DIAGON|DIAG|DIG|DGN|DIAGN|DIA|DNL) /", "DG ",$this->strAddress);

    $this->strAddress=preg_replace("/^TV/", "TV ",$this->strAddress);
    $this->strAddress=preg_replace("/^DG/", "DG ",$this->strAddress);
    $this->strAddress=preg_replace("/^C /", "CL ",$this->strAddress);
    $this->strAddress=preg_replace("/^K /", "KR ",$this->strAddress);
    $this->strAddress=preg_replace("/^T /", "TV ",$this->strAddress);
    $this->strAddress=preg_replace("/^D /", "DG ",$this->strAddress);

//    $this->strAddress=preg_replace("/([A-Z])([0-9])/","$1 $2",$this->strAddress);

    $this->strAddress=preg_replace("/\\b(INTERIOR|INTER)\\b/", "INT",$this->strAddress);
    $this->strAddress=preg_replace("/\\b(ENTRADA|ENTR)\\b/", "ENT",$this->strAddress);
    $this->strAddress=preg_replace("/\\b(BLOQUE|BLOQ)\\b/", "BL",$this->strAddress);
    $this->strAddress=preg_replace("/\\b(TORRE|TOR|TR)\\b/", "TRR",$this->strAddress);
    $this->strAddress=preg_replace("/\\b(EDIFICIO|EDIFI|EDF|EDI)\\b/", "EDIF",$this->strAddress);
    $this->strAddress=preg_replace("/\\b(APARTAMENTO|APTO|APO|APT)\\b/", "AP",$this->strAddress);
    $this->strAddress=preg_replace("/\\b(OFICINA|OFICIN|OFICI|OFIC|OFI)\\b/", "OF",$this->strAddress);
    $this->strAddress=preg_replace("/\\b(LOCAL|LOC)\\b/", "LC",$this->strAddress);
    $this->strAddress=preg_replace("/\\b(LOTE|LOT)\\b/", "LT",$this->strAddress);
    $this->strAddress=preg_replace("/\\b(CONSULTORIO|CONSULT)\\b/", "CONS",$this->strAddress);
    $this->strAddress=preg_replace("/\\b(BODEGA|BGA|BD|BDG)\\b/", "BOD",$this->strAddress);

    if($this->defaultSouth == 1) $this->strAddress=preg_replace("/([0-9]) *S$| S /","$1 SUR ",$this->strAddress);
		else $this->strAddress=preg_replace("/([0-9]) *S$/","$1 SUR",$this->strAddress);
//    $this->strAddress=preg_replace("/ S$/"," SUR",$this->strAddress);

    $this->strAddress=preg_replace("/ +/"," ",$this->strAddress);
//		preguntar($this->strAddress);

//	+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//		$this->strAddress=preg_replace("/([0-9])S$/","\\1 SUR",$this->strAddress);
//		$this->strAddress=preg_replace("/ S$/"," SUR",$this->strAddress);

//		$this->strAddress=str_replace(" E ", "ESTE ",$this->strAddress);
//		if(substr($this->strAddress,-2) == " E") $this->strAddress.="STE";

	}

	function findCardinality(){
	//Si es SUR
		if ($this->defaultSouth==0 && $pos = strpos($this->strAddress, "SUR")){
			$this->strAddress=str_replace("SUR", "",$this->strAddress);
			$this->sur=1;
		}
	//Si es NORTE
		if ($this->defaultSouth==1 && $pos = strpos($this->strAddress, "NORTE")){
			$this->strAddress=str_replace("NORTE", "",$this->strAddress);
			$this->sur=0;
		}
	//Si es OESTE
		if ($this->defaultEast==1 && $pos = strpos($this->strAddress, "OESTE")){
			$this->strAddress=str_replace("OESTE", "",$this->strAddress);
			$this->este=0;
		}
	//Si es ESTE
		if ($this->defaultEast==0 && $pos = strpos($this->strAddress, "ESTE")){
			$this->strAddress=str_replace("ESTE", "",$this->strAddress);
			$this->este=1;
		}
	}

	function findWayType(){

		if (!($pos = strpos($this->strAddress, " "))){
			$this->suffix = $this->strAddress;
			$this->set("errorCode",2);
//			$this->set("error","No se pudo traducir la direccin.");
			return(FALSE);
		}
		//--Revisin de si es calle carrera o lo que sea---------------------------------
		$temp = substr($this->strAddress, 0, $pos);
		if ($temp == "AC" || $temp == "AK" || $temp == "CL" || $temp == "DG" || $temp == "KR" || $temp == "TV") $this->tipo_via = $temp;
		elseif ($temp == "CALLE" || $temp == "CLL" || $temp == "CLE" || $temp == "CALL" || $temp == "CLLE") $this->tipo_via = "CL";
		elseif ($temp == "CARRERA" || $temp == "CRA" || $temp == "CRRA" || $temp == "KRA" || $temp == "K" || $temp == "CR" )$this->tipo_via = "KR";
		elseif ($temp == "DIAGONAL" || $temp == "DIAG" || $temp == "DIG" || $temp == "DIA" || $temp == "DIAGN" || $temp == "DGN" || $temp == "DIAGON") $this->tipo_via = "DG";
		elseif ($temp == "TRANSVERSAL" || $temp == "TRASNVERSAL" || $temp == "TRANSV" || $temp == "TRAV" || $temp == "TRAN" || $temp == "TRANS" || $temp == "TRANV" || $temp == "TRV"  || $temp == "TRA" || $temp == "TR") $this->tipo_via = "TV";
		elseif ($temp == "AV"){
			if(preg_match("/^AV [0-9]+ ?[A-Z]? [0-9]/",$this->strAddress,$matches)){
				$this->set("errorCode",10);
				return(FALSE);
			}
			if(preg_match("/^AV ([0-9]+ ?[^0-9]+)([0-9].*)/",$this->strAddress,$matches)){
				$this->nombre_comun=trim($matches[1]);
			}
			elseif(preg_match("/^AV ([^0-9]+)([0-9].*)/",$this->strAddress,$matches)){
				$this->nombre_comun=trim($matches[1]);
			}
			else{
				$this->set("errorCode",2);
				return(FALSE);
			}
			$this->nombre_comun=preg_replace("/\b(LAS|LA|LOS|LO|DEL|DE|EL|AVENIDA|AV|AL|A)\b/","",$this->nombre_comun);
			$this->nombre_comun=preg_replace("/ +/"," ",trim($this->nombre_comun));
			$this->strAddress="AV 00 " . trim($matches[2]);
			$this->tipo_via = "AV";
/*
			preguntar($this);
			die();
			$this->tipo_via = "AV";
			$primer_num=encnum($this->strAddress);
			$temp1=substr($this->strAddress, -strLen($this->strAddress) + $primer_num - 1);
			if ($primer_num == 4){//Si es p-e av 127
				$temp2=substr($temp1, 0, strPos($temp1," "));
				$this->nombre_comun = trim("AVENIDA " . $temp2);
			}
			else{
				$nombre=substr($this->strAddress, 0, encnum($this->strAddress) - 2);
				$nombre=str_replace("AV ", "AVENIDA ",$nombre);
				$this->nombre_comun = trim($nombre);
				$this->strAddress="AV 00 " . $temp1;
			}
*/
		}
		elseif ($temp == "AU"){
			$this->tipo_via = "AU";
			$primer_num=encnum($this->strAddress);
			$temp1=substr($this->strAddress, -strLen($this->strAddress) + $primer_num - 1);
			if ($primer_num == 4){//Si es p-e av 127
				$temp2=substr($temp1, 0, strPos($temp1," "));
				$this->nombre_comun = trim("AUTOPISTA " . $temp2);
			}
			else{
				$nombre=substr($this->strAddress, 0, encnum($this->strAddress) - 2);
				$nombre=str_replace("AU ", "AUTOPISTA ",$nombre);
				$this->nombre_comun = trim($nombre);
				$this->strAddress="AU 00 " . $temp1;
			}
		}
		else{
			$this->tipo_via = "--";
			$this->suffix = $this->strAddress;
			$this->set("errorCode",2);
//			$this->set("error","No se pudo traducir la direccin.");
			return(FALSE);
		}
		$this->strAddress = substr($this->strAddress, -strLen($this->strAddress) + $pos +1);
		$this->strAddress = trim($this->strAddress);
		if ($this->nombre_comun != ""){
			if(!$this->searchCommonName()){
				$this->set("errorCode",4);
//				$this->set("error","Es una avenida, pero no se encuentra en la base de datos.");
				return(FALSE);
			}
		}
		return TRUE;
	}

	function groupAddress(){
		/*
			 Funcin que agrupa las direcciones en bloques de [Nomenclatura] [generadora] y [distancia]
		 */
		$string=ereg_replace(" +"," ",trim($this->strAddress));
		$this->strAddress="";
		$this->strAddress=$string{0};
		$bloques=1;
		for($i=1;$i<strlen($string);$i++){
			if($bloques>2 && $string{$i}==" ") break;
			if($string{$i}!=" " || is_numeric($string{$i+1})){
				if($string{$i}==" ") $bloques++;
				$this->strAddress.=$string{$i};
			}
		}
		if($i<strlen($string)) $this->suffix=trim(substr($string,$i));
		//    $this->strAddress=preg_replace("/([0-9])bis/","\\1 bis",$this->strAddress);
		return TRUE;
	}

	function structure(){
		$arrayParts=explode(" ",$this->strAddress);
		if(sizeof($arrayParts)==2) $arrayParts[2]="00";
		if(sizeof($arrayParts)!=3) return(FALSE);
		if(!is_numeric($arrayParts[2])){
			if(!preg_match("/^([0-9]+)(.*)$/",$arrayParts[2],$matches)) return(FALSE);
			$this->set("suffix",trim($matches[2] . " " . $this->suffix));
			$arrayParts[2]=$matches[1];
		}
		$this->nomenclatura = $arrayParts[0];
		$this->generadora = preg_replace("/BIS$/","",$arrayParts[1]);
		$this->distancia=$arrayParts[2];
		// Si es Bis la nomenclatura:
		if ($pos = strpos($arrayParts[0], "BIS")){ 
			$this->nom_bis = substr($arrayParts[0], $pos,3);
			$this->let_bis = substr($arrayParts[0], $pos+3);
			$this->nomenclatura=substr($arrayParts[0], 0,$pos);
			$arrayParts[0]=substr($arrayParts[0], 0,$pos);
		}
		// Si es Bis la generadora:
		if ($pos = strpos($arrayParts[1], "BIS")){
			$this->gen_bis = substr($arrayParts[1], $pos);
			$arrayParts[1]=substr($arrayParts[1], 0,$pos);
		}
		//Ver si trae letra(s) la nomenclatura
		$string=$arrayParts[0];
		for($i=0;$i<strlen($string);$i++) if(!is_numeric($string{$i})){
			$this->nomenclatura=substr($string, 0,$i);
			$this->nom_letra = substr($string, $i);
			break;
		}
		//Ver si trae letra(s) la generadora
		$string=$arrayParts[1];
		for($i=0;$i<strlen($string);$i++) if(!is_numeric($string{$i})){
			$this->generadora = substr($string, 0, $i);
			$this->gen_letra=substr($string, $i);
			break;
		}
		if($this->nom_letra=="KR" || $this->nom_letra=="CL" || $this->nom_letra=="CON") $this->nom_letra="";
		if(!is_numeric($this->nomenclatura) || !is_numeric($this->generadora)) return(FALSE);
		return TRUE;
	}

	function translate(){
		/*
			 Funcin que descompone la direccin ingresada en $this->strAddress y trata de
			 organizarla de manera estructurada para analizarla.
		 */
		$this->findCardinality();
		if(!$this->findWayType()){
			if($this->get("errorCode")=="") $this->set("errorCode",2);
//			$this->set("error","No se pudo traducir la direccin.");
			return(FALSE);
		}
		$this->groupAddress();
		if(!$this->structure()){
			$this->set("errorCode",2);
//			$this->set("error","No se pudo traducir la direccin.");
			return(FALSE);
		}
		$this->createCode();
		return TRUE;
	}

	function set($attribute,$value,$die_on_fail=TRUE){
		parent::set($attribute,$value,$die_on_fail);
		if($attribute=="defaultSouth"){
			$this->sur=$value;
			$this->strAddress=str_replace(" N ", " ",$this->strAddress);
		}
		if($attribute=="defaultEast") $this->este=$value;
	}

}

function encnum($cadena){
	$tamano = strLen($cadena);
	For ($i = 1; $i<=$tamano; $i++){
		$ascii = ORD($cadena);
		If (($ascii >= 48) && ($ascii <= 57)){
			$encnum = $i;
			return $encnum;
		}
		$cadena = substr($cadena, -$tamano + $i);
	}
	$encnum = 0;
	return $encnum;
}


?>

